<template>
<div>
    <br/>

  <ul class="nav p-3">

    <li class="nav-item">
      <div class="dropdown">
        <button class="btn btn-info dropdown-toggle" role="button" id="dropdownMenuLink" data-bs-toggle="dropdown" aria-expanded="false">
          Typ statku powietrznego
        </button>

        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink">
          <li v-for="as_type in airship_types_list" :key="as_type.id">
            <input class="form-check-input" type="checkbox" v-model="as_type.checkbox" v-bind:value="as_type.id" id="flexCheckDefault" @change="(event) => SelectFilter(event, airship_types_selected_ids)">
            <label class="form-check-label" for="flexCheckDefault">
              {{as_type.name}}
            </label>
           </li>
        </ul>
      </div>
    </li>

    <li class="nav-item">

      <div class="dropdown">
        <button class="btn btn-info dropdown-toggle" role="button" id="dropdownMenuLink" data-bs-toggle="dropdown" aria-expanded="false">
          Numer statku powietrznego
        </button>

        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink">
          <li v-for="airship in airships_list" :key="airship.id">
            <input class="form-check-input" type="checkbox" v-model="airship.checkbox" v-bind:value="airship.id" id="flexCheckDefault" @change="(event) => SelectFilter(event, airships_selected_ids)">
            <label class="form-check-label" for="flexCheckDefault">
              {{airship.number}}
            </label>
           </li>
        </ul>
      </div>

    </li>

    <li class="nav-item">
      <div class="dropdown">
        <button class="btn btn-info dropdown-toggle" role="button" id="dropdownMenuLink" data-bs-toggle="dropdown" aria-expanded="false">
          Poziom Obsług
        </button>

        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink">
          <li v-for="level in handlings_level_list" :key="level.id">
            <input class="form-check-input" type="checkbox" v-model="level.checkbox" v-bind:value="level.id" id="flexCheckDefault" @change="(event) => SelectFilter(event, handlings_selected_ids)">
            <label class="form-check-label" for="flexCheckDefault">
              {{level.level}}
            </label>
           </li>
        </ul>
      </div>
    </li>
    <br/>

    <li class="nav-item px-2">
      data rozpoczęcia od:
      <input type="date" v-model="from_start_date_filter" />
      do:
      <input type="date" v-model="to_start_date_filter" />
    </li>

    <li class="nav-item px-1">
      <button class="btn btn-dark mx-1" type="button" @click=ApplyFilters>
        Filtruj
      </button>

      <button class="btn btn-secondary mx-1" type="button" @click=ClearFilters>
        Wyczyść filtry
      </button>

      <button class="btn btn-primary mx-1" v-if="$store.state.user?.is_superuser" type="button" @click=on_add_new>Dodaj</button>
    </li>

  </ul>



  <table class="table">
    <thead>
      <tr>
        <th scope="col">Numer</th>
        <th scope="col">Statek powietrzny</th>
        <th scope="col">Ilość roboczogodzin</th>
        <th scope="col">data rozpoczęcia</th>
        <th scope="col">data zakończenia</th>
        <th scope="col">zlecający</th>
        <th scope="col">poziom obsług</th>
        <th scope="col">stan wykonania</th>
        <th scope="col">zatwierdzona</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="header in card_headers_list" :key="header.id">
        <th scope="row">{{header.number}}</th>
        <td>{{header.airship_serialized.number}} {{header.airship_serialized.type_serialized.name}}</td>
        <td>{{header.man_hours}}</td>
        <td>{{header.start_date}}</td>
        <td>{{header.finish_date}}</td>
        <td>{{header.issuer_partial_serialized.first_name}} {{header.issuer_partial_serialized.last_name}} </td>
        <td>{{header.handlings_level_serialized.level}} {{header.handlings_level_serialized.air_ship_type_serialized.name}}</td>
        <td>{{header.complete_level}}</td>
        <td>{{header.approved}}</td>
        <td><RouterLink :to="'/card_handlings/?header_id=' + header.id +
          '&handling_id=' + header.handlings_level +
          '&airship_type_id=' + header.airship_serialized.type_serialized.id">obsługi
        </RouterLink></td>
        <td>
          <div class="btn-group" v-if="$store.state.user?.is_superuser">
            <button class="btn btn-primary" v-if="!header.approved" @click="ApproveCardHandling(header.id)">Zatwierdź kartę</button>
            <button class="btn btn-primary" v-else-if="IsCompleted(header) && !header.finish_date" @click="FinishCardHandling(header.id)">Zakończ kartę</button>
            <button class="btn btn-secondary" @click="EditCardHandling(header.id)">Edytuj</button>
            <button class="btn btn-secondary" @click="DeleteCardHandling(header.id)">Usuń</button>
          </div>
        </td>
      </tr>
    </tbody>
  </table>

  </div>
</template>

<script>
import { setAuthorizationToken } from "../../utils/authUtils";
import { getCardHeader, getAirshipTypes, getAirships, getHandlingsLevels,
         deleteDataBaseObject, approveHeader, finishHeader } from "../../utils/apiUtils";
import router from "../../router";

const card_header_url = "http://127.0.0.1:8000/handlings/card_header/";

export default {
  // @TODO dodać belkę z wyszukiwaniem, po po typie statku, po numerze statku, po poziomie obsług, po dacie
  // @TODO defaultowo pokazane wszytkie posotowane po dacie
  name: "CardHandlingBrowse",
  props: {
    on_edit : Function,
    on_add_new : Function
  },
  data: function() {
    return {
      card_headers_list: [],

      airships_list: [],
      airship_types_list: [],
      handlings_level_list: [],

      airships_selected_ids: new Set(),
      airship_types_selected_ids: new Set(),
      handlings_selected_ids: new Set(),

      from_start_date_filter: null,
      to_start_date_filter: null
    };
  },
  methods: {
    ApplyFilters() {
      (async () => {
          const params = {
            filters: {
              airship: JSON.stringify(Array.from(this.airships_selected_ids.values())),
              airship_type: JSON.stringify(Array.from(this.airship_types_selected_ids.values())),
              handling_level : JSON.stringify(Array.from(this.handlings_selected_ids.values())),
              start_date_from: this.from_start_date_filter,
              start_date_to: this.to_start_date_filter
            }
          }
          setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
          this.card_headers_list = await getCardHeader(params);
      })();
    },
    ClearFilters() {
      for (let airship of this.airships_list) {
        airship.checkbox = false
      }
      for (let type of this.airship_types_list) {
        type.checkbox = false
      }
      for (let type of this.handlings_level_list) {
        type.checkbox = false
      }

      this.airships_selected_ids.clear()
      this.airship_types_selected_ids.clear()
      this.handlings_selected_ids.clear()
    },
    SelectFilter(event, selected_set) {
      if (event.target.checked) {
        selected_set.add(parseInt(event.target.value, 10))
      } else {
        selected_set.delete(parseInt(event.target.value, 10))
      }
    },
    ApproveCardHandling(id) {
      (async () => {
        await approveHeader(id, {"approved": true})
        this.ApplyFilters()
      })()
    },
    FinishCardHandling(id) {
      (async () => {
        await finishHeader(id, {"finished": true})
        this.ApplyFilters()
      })()
    },
    IsCompleted(header) {
      if (!header.complete_level) {
        return false
      }

      const completeChars = header.complete_level.split("/")

      if (completeChars.length != 2) {
        console.log("CardHeader: wrong format of complete level")
        return false
      }

      return (parseInt(completeChars[0]) / parseInt(completeChars[1])) == 1

    },
    EditCardHandling(id) {
      this?.on_edit(id);
    },
    DeleteCardHandling(id) {
      if (window.confirm("Are you sure ?")) {
        (async () => {
          try {
              setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
              const response = await deleteDataBaseObject(card_header_url + id + "/");
              if (response.status === 204) {
                  window.alert("card handling deleted");
                  this.card_headers_list = await getCardHeader();
                  this.ApplyFilters();
              }
          } catch (error) {
              window.alert("cannot delete this card handling type");
          }
      })();
      }
    }
  },
  computed: {
    isAuthenticated: function() {
      return this.$store.state.isAuthenticated
    }
  },
  mounted: function() {
    (async () => {
        setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
        this.card_headers_list = await getCardHeader();
        this.airship_types_list = await getAirshipTypes();
        this.airships_list = await getAirships();
        this.handlings_level_list = await getHandlingsLevels();
    })();
  }
};
</script>

<style scoped>
/* @TODO do something with this styles!!! - make it global or something */
</style>>